package devoir03;

import java.io.File;
import java.util.List;

import javax.swing.DefaultListModel;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;

import devoir03.listeners.DocumentSelectionListener;
import devoir03.listeners.LireActionListener;
import devoir03.listeners.MotSelectionListener;
import devoir03.listeners.QuitterActionListener;
import devoir03.modele.IndexImplementation;
import devoir03.modele.IndexInterface;
import devoir03.modele.LecteursDeDocuments;
import devoir03.modele.UnDocument;

/**
 * Application. Vous devrez compléter cette classe.
 * 
 * @author rosmord
 * 
 */
public class NavigateurDocumentsApplication {
	/**
	 * Interface graphique.
	 */
	private InterfaceGraphiqueNavigateur jLecteur = new InterfaceGraphiqueNavigateur();
	private IndexInterface index= new IndexImplementation();
	
	public NavigateurDocumentsApplication() {
		creerMenu();
		activer();
		jLecteur.getFrame().setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		jLecteur.getFrame().setVisible(true);
	}

	private void activer() {
		à compléter...
	}

	/**
	 * Crée et active les menus.
	 */
	private void creerMenu() {
		JMenu menu = new JMenu("Fichiers");
		JMenuItem lireItem = new JMenuItem("Ouvrir");
		lireItem.addActionListener(new LireActionListener(this));
		JMenuItem quitterItem = new JMenuItem("Quitter");
		quitterItem.addActionListener(new QuitterActionListener(this));
		menu.add(lireItem);
		menu.add(quitterItem);
		JMenuBar menuBar = new JMenuBar();
		menuBar.add(menu);
		jLecteur.getFrame().setJMenuBar(menuBar);
	}

	/**
	 * Lit le contenu d'un dossier et recopie les données au bons endroits (dans
	 * les listes).
	 * 
	 * @param repertoire
	 */
	public void lire(File repertoire) {
		
		étudiez attentivement le code de cette fonction (il fonctionne; il suffit juste de supprimer cette ligne.)
		
		index.effacer();		
		LecteursDeDocuments lecteur = new LecteursDeDocuments(repertoire);
		while (lecteur.aDocument()) {
			UnDocument doc = new UnDocument(
					lecteur.getNomFichier(), lecteur.getContenuFichier());
			index.indexerDocument(doc);
			lecteur.suivant();
		}		
		DefaultListModel model= new DefaultListModel();
		for (String mot: index.getMotsIndexes()) {
			model.addElement(mot);
		}
		// On vide la liste des documents affichés
		jLecteur.getDocumentPourIndexJList().setModel(new DefaultListModel());
		jLecteur.getIndexJList().setModel(model);
	}

	public InterfaceGraphiqueNavigateur getInterfaceUtilisateur() {
		return jLecteur;
	}

	public void selectionneDocument() {
		Que se passe-t-il quand on sélectionne un document ?
	}

	public void selectionnerMot() {
		Que se passe-t-il quand on sélectionne un mot ?
	}
}
